2.4.1 [2026-08-21]
 peripherial:
   * в modbus добавлен параметр reverseBytesInWord

2.4.0 [2026-07-23]
 + Добавлен плагин arctrm (архивация термометрии)
 roboplant:
   * В TAGA исправлен баг инвертирования, появившийся в 2.2.3
 peripherial:
   + В promauto.termo5 добавлены теги Mode, ModeForcePdv и ModeResetCnt, а также параметр modeResetCntMax

2.3.2 [2026-06-17]
 roboplant:
   * Рефакторинг LOADA, MCHB, MDTA, SEQC, SEQD, ZDVA, ZDVS, ZDVT
 
2.3.1 [2026-03-27]
 + Добавлены svc-скрипты (замена wrapper на x64)
 - В lib больше не копируются зависимости для тестирования
 core:
   + Добавлена команда запуска daemon (синоним quiet)
   + В FuncTag добавлен параметр type и distinct
 peripherial:
   + В модуле promauto.gelios.dozkkmc:
      + добавлен тег OnlineOutput (производительность кг/ч последнего цикла)
      + добавлена поддержка команды 12 (стоп)

2.3.0 [2026-01-14]
 + Обновлены зависимости до последних версий
 * Рефакторинг кода для перехода на java21 (Module переименован в JrModule)
 serial:
   + Добавлен порт local, использующий библиотеку jSerialComm
   - Библиотека jssc удалена, а порт jssc - это синоним local
   * Исходный код порта usriot полностью переработан, а также добавлен синоним usr.
 messenger:
   * Библиотека javax.mail заменена на jakarta.mail-api

2.2.4 [2026-01-09]
 serial:
   + Добавлен порт rfc2217
   + Добавлен параметр no_init для портов usriot и rfc2217

2.2.3 [2025-12-29]
 roboplant:
   * Исправлено копирование значение в TAGA для всех типов тегов (было только для INT)
   + Добавлены блоки TRIGW, DBGA, DBGB, DBGC
 wessvr:
   * Исправлен import - несоответствие полей в старой и новой БД

2.2.2 [2025-09-26]
 database:
   + Добавлен параметр logdbscr для управления включением/отключением логирования работы dbscr
 wessvr:
   + Добавлена команда wessvr:import <db> uvkrec_stat <tbl>
   + Полный рефакторинг dbscr-скрипта
 tagsaver:
   + Добавлена возможность сохранять в string-тегах символы cr, lf и tab
 script:
   + Добавлен встроенные скрипты: CsvToSqlImportScript, SqlToCsvExportScript, WatchdogScript


2.2.1 [2025-04-06]
 core:
   + Добавлена глобальные команда и параметр appname
 tagsaver:
   + Добавлена запись в лог при реинициализации
 peripherial:
   + В модуле promauto.robo добавлен параметр use.descr
   + Добавлен модуль mercury
 roboplant:
   + Добавлен синоним параметру useDescr - use.descr
 wrapper:
   + Обновлена версия Tanuki Wrapper 3.5.60


2.2.0 [2025-02-21]
 + Добавлен плагин motohr (учет моточасов)
 roboplant:
   + В параметре useDescr можно использовать значение hidden
 peripherial:
   * В gelios.pass старт и стоп команды через SetCmd теперь выполняются с повтором до перехода в нужное состояние


2.1.11 [2025-01-13]
 peripherial:
   + Добавлен mul для тегов в модуле modbus


2.1.10 [2025-01-09]
 roboplant:
   * Устранена ошибка NPE, возникавшая при релоаде соседних модулей, и при наличии канала, в котором прописан строкой несуществующий адрес


2.1.9 [2024-12-25]
 roboplant:
   * Устранено кратковременное обнуление тегов после выполения reload


2.1.8 [2024-11-27]
 roboplant:
   * Блок OPER адаптирован для работы с LONG и DOUBLE значениями


2.1.7 [2024-11-17]
 core:
   + Добавлен глобальный параметр debug.logging 
 peripherial:
   * В modbus исправлена множественная запись одного регистра
   + Для протокола AA55 добавлена поддержка параметра debug.logging


2.1.6 [2024-11-06]
 jrbustcp:
   * В сервере исправлена команда CMD_CRC для значения NaN, полученного нестандартным способом
   + Добавлено логирование расчета значения CRC для команды CMD_CRC на сервере
 peripherial:
   * В owen.trm138 исправлен прием ошибок датчиков


2.1.5 [2024-04-18]:
 roboplant:
   + Добавлено устройство: BITR
 peripherial:
   + Добавлен модуль kipr.bos1


2.1.4 [2024-03-20]
 roboplant:
   * В DLY можно задавать отрицательное время для выполнения задержки нуля


2.1.3 [2024-01-31]
 peripherial:
   + В promauto.gelios.pass и promauto.gelios.dozkkmc добавлены теги SYSTEM.SN (серийный номер) и Replacement (флаг замены устройства)
   + В wessvr.adapter добавлена поддержка тегов SN и Replacement
 wessvr:
   + Добавлена поддержка режима замены устройства по серийному номеру и тегу Replacement для устройств типа Gelios и Standard
 roboplant:
   * Исправлена утечка памяти при reload - при использовании связывания (connect) не удалялась ссылка на временный модуль в ConnetManager


2.1.2 [2024-01-24]
 peripherial:
   + Добавлен модуль promauto.gelios.multipacker
   + Добавлен модуль easydrive.ed3100
 roboplant:
   * В MDTA в режиме инверсии Alarm не блокировался Alarm
   * Исправлена утечка памяти при reload - не вызывался removeSignalListener при закрытии
 tagsaver:
   * Исправлена утечка памяти при reload - не вызывался removeSignalListener при закрытии


2.1.1 [2023-12-11]
 core:
   + Добавлена возможность создавать функциональные теги func.tags для всех модулей
   + В func.tags добавлена фунция усреднения avg
 peripherial:
   + В modbus добавлен параметр forcedWriteWO
   + Добавлены команда модуля и параметр logreq для вывода успешных запросов
 wrapper:
   + Обновлена версия Tanuki Wrapper 3.5.54


2.1.0 [2023-11-29]
 + Добавлен плагин raduga (управление многокомпонентным дозированием)
 jrbustcp:
   * Оптимизировано формирование списка тегов на сервере
 peripherial:
   + В modbus добавлен параметр тега readOnce
   + В modbus добавлены глобальные параметры writeSingle и writeMultiple на уровне модуля
   + В modbus добавлен параметр bitNameOnly для получения имени битового тега без имени основного тега
   + В promauto.prks добавлена поддержка команды А0 (чтение дискретных входов)
   + В promauto.prks и pdat добавлен параметр noFreq
   + В promauto.gelios.dozkkmc добавлено: режим real-time эмуляции; задержка команды разгрузки; индикация стабильности текущего веса
   + В owen.trm138 добавлены теги ошибок датчиков и параметр badIfError
 roboplant:
   + В MDTA добавлен флаг использования статуса b10 (FLAG_USE_STATUS) 
   + В STGA добавлены флаги режимов: циклический/одиночный; триггерный
   + При связывании к одному внешнему модулю можно привязывать более одного логического блока
 tagsaver:
   * Исправлена работа с удаленными тегами
 wessvr:
   + Добавлен параметр ignoreZeroStat для игнорирования записи нулевых итогов


2.0.2 [2023-07-28]
 roboplant:
   + В ZDVT тег Param отображает состояние входов датчков и выходов управления
 arcsvr:
   * Добавлен desc-индекс для таблиц данных по полю REC для ускорения загрузки arcval
 peripherial
   + Добавлен модуль centa.urz
   + В модуле promauto.gelios.pass добавлен параметр skip20
   + В модуле promauto.gelios.pass добавлена поддержка режима multireq для доп.регистров
   * В модуле akkont.pass добалены теги управления
   * В модуле wessvr.adapter исправлена передача тега SYSTEM.UpdateTime
   * В модуле promauto.gelios.dozkkmc добавлены теги Stable*


2.0.1 [2022-11-24]
 peripherial:
   + В promauto.gelios.flow добавлена поддержка удаленной консоли
   * В WessvrAdapter исправлен баг получения long-значения веса
   * Исправлено обновление статуса тега для добавленных тегов после reload
   * в promauto.gelios.dozkkmc добавлена команда 10 для остановки загрузки
 wrapper:
   + Обновлена версия Tanuki Wrapper 3.5.50


2.0.0 [2022-04-27]
 + Выполнен переход на систему сборки maven
 + Используется один исполняемый jar, убрано разбиение на плагины
 + Обновлены зависимости до последних версий

=====

1.7.0 []
 docker:
   + Добавлена контейнеризация docker'ом
 tcpserver:
   * Исправлен баг команды reload через tcpconsole
 peripherial:
   + Добавлены битовые теги в modbus
   + Добавлен модуль promauto.gelios.dozman
 kkmansvr:
   + Добавлени плагин kkmansvr


1.6.1 []
 roboplant:
   + Добавлен строковый тег descr в MCHB, MDTA, ZDV*, SEQD
   + В MDTA добавлен выход TrigRes
 jrbustcp:
   + Добавлена аутентификация по ключу
   + В сервере добавлена фильтрация по ip
 core:
   + Добавлена команда keygen для создания пары ключей

1.6.0 [2021-12-13]
 * Обновлены зависимости до последних стабильных версий
 wessvr:
   + Добавлена поддержка интервала длительностью в сутки для архивов


1.5.5 [2021-10-27]
 peripherial:
   + Добавлен модуль termo.mux
   + Для всех модулей с протоколом AA55 добавлен тег firmware
   + Добавлен модуль korenn.pass
 roboplant:
   + В MCHB добавлен CtrlBeep, расширена функциональность Control
   * Испрален баг ZCTA при reload
 wessvr:
   + В скрипт добавлены процедуры FETCH_MAIN_SUM, FETCH_STAT_SUM и FETCH_ARCVAL_LAST
 wrapper:
   + Обновлена версия Tanuki Wrapper 3.5.46


1.5.4 [2021-08-27]
 peripherial:
   + Добавен запрос firmware и resetcnt для модулей плат promauto
   + Добавлен модуль akkont.pass
   + Добавлен модуль tenzom
   + В модуль promauto.gelios.pass добавлен параметр bitStateConv
 roboplant:
   + Добавлено устройство: LOADB
 task:
   * Исправлено долгое ожидание завершения задачи
   + Добавлен параметр delayStart
 jrbustcp:
   + Добавлена команда CRC
 arcsvr:
   + В dbscr добавлена if-функция has_records
   + Добавлена система архивации сообщений version 2


1.5.3 [2021-04-21]
 core:
   + Добавлена команда консоли rpt
 arcsvr:
   + Добавлена привязка выполнения записи ко времени, кратному period_ms, для arcval.robo


1.5.2 [2021-02-11]
 peripherial:
    + Добавлен параметр SumWeightMax в модуле promauto.gelios.dozkkmc
 roboplant:
    + Добавлено устройство: FRQA, STGA


1.5.1 [2020-12-23]
 database:
    + Добавлена функция has_procedure в dbscr
 jrbustcp:
    + Добавлен режим Channel Watchdog
    + Добавлены параметры в клиенте excludeExternal, includeHidde и setHidden
 wessvr:
    + Добавлена функция архивирования простоев в таблицу statidle


1.5.0 [2020-12-15]
 arcsvr:
    + Добавлена поддержка параметра Type в atg-файлах
 database:
    + Добавлена проверка версии сервера
 jrbustcp:
    + Добавлена поддержка передачи статуса тега
 kkormsvr:
    + Добавлен плагин kkormsvr
 peripherial:
    + Добавлен модуль promauto.gelios.dozkkmc
    + В модуль promauto.gelios.pass добавлен параметр packer
    + Добавлена карта адресов каналов CHANNELMAP
 serial:
    * Исправлен баг в usr410: не устанавливалась скорость 115200


1.4.1 [2020-07-22]
 core: 
    + Добавлены консольные команды l, ll, lf, lb
 arcsvr:
    + Удален устаревший параметер tagsources.
 peripherial:
    * В schneider.atv31 добавлен параметр KeepFreqSet
 database:
    + При создании базы данных firebird выполняется  setDefaultCharacterSet
    * Обновлен драйвер jaybird до 3.0.9


1.4.0 [2020-04-20]
 Выполнен переход на git.
 core:
    + Добавлен класс типа тега Long
    + Для всех модулей добавлена возможность устанавливать значения и флаги тегов yml-конфигурации.
    * Рефакторинг, оптимизация.
 arcsvr:
    + В arcmes.robo добавлена возможность присвоения тегу индивидуального place в описании тега
 database:
    + Добавлен лимит вывода строк командой sql
 jrbustcp:
    + Добавлен плагин jrbustcp, работающий в режими сервера/клиента по протоколу JRBusTcp.
      Основные отличия от rpsvrtcp/rpclient:
        - бинарный формат
        - передача тегов всех типов
        - поддержка сжатия gzip
        - поддержка ssl (в разработке)
 peripherial:
    + Добавлен модуль wessvr.adapter для работы в устройством Standard (wessvr), позволяющий
      wessvr работать с любым модулем, имеющим какие-либо счетчики.
    + В модулях modbus и omron.fins добавлен тип данных UINT32
 roboplant:
    + Добавлены внешние каналы, дающие возможность использовать любые внешние теги вместо
      классических адресов в устройствах типа MCHB, MDTA, ZDVA и т.д.
    + Добавлена поддержка чтения типа тега из rpp
 wessvr:
    + Добавлено устройство Standard для работы в паре с wessvr.adapter (peripherial)
    * Изменен скрипт создания новой базы данных. В arcout индекс по dt изменен на убывающий
      в целях увеличения производительности клиентов базы данных при построении графиков.
      Данное изменение желательно также произвести в существующих базах.


1.3.7 [2020-01-09]
 wrapper:
    + Подготовлен к использованию новый враппер yajsw
 peripherial:
    + Добавлен модуль owen.trm138
    + Добавлен модуль gelios.dozkkorm
    + Добавлен модуль gelios.dozkkmc
    + Добавлен модуль tenzom.tb09
    + Добавлен модуль omron.fins
 wessvr:
    + Добавлен модуль gelios.dozkkorm
 roboplant:
    * Исправлен баг в DeviceI7024: не передавались значения на запись по адресу
    + Добавлено устройство OUTA
    + Добавлено устройство DRZ12
 arcsvr:
    + Добавлен новый тип сообщений arcmes.regex
    + Добавлен параметр place по умолчанию
    + Добавлено автоматическое удаление старых записей из MESLIST
 serial:
    + Добавлен порт finsudp


1.3.6 [2019-02-15]:
 arcsvr:
    + Добавлен параметр period_align для regex архивов
 tcpserver:
    + Перевод netty с 3 на 4 версии

1.3.5 [2019-02-01]
 peripherial:
    * Добавлен параметр multireq в promauto.gelios.pass
 wrapper:
    + Добавлены необходимые для работы wrapper конфиг.файлы


1.3.4 [2019-01-15]
 core:
    * Скрытые yml-файлы, начинающиеся с точки, игнорируются при загрузки
 database:
    + Добавлено условие has_trigger
    + Добавлено tabletags
 arcsvr:
    + Добавлена команда nolink
 tcpconsole:
    * Добавлено преобразование вывода в UTF-8


1.3.3 [2018-12-05]
 peripherial:
    + Добавлен модуль kontakt1.tur01 
    + Добавлен модуль promauto.gelios.maslo2v2
    * Переписан с нуля модуль hygrostek.da301 (не было задержки при передачи, что критично для оригинального итальянца; значения из ответа извлекались не правильно; не работали команды управления; и т.д.)
 script:
    * Добавлена возможность полностью описать ScriptJava класс с дополнительными импортами
 wessvr:
    + Добавлен модуль geslios.maslo2v2


1.3.2 [2018-11-26]
 tagsaver:
    * Исправлен баг в onSignalReload. Проявлялось в виде ошибки при загрузке chng (bad crc) после reload сопутствующего roboplant модуля
 peripherial:
    + Добавлены модули ОВЕН: owen.ma110_16r, owen.mu110_81, owen.mv110_16d, owen.mv110_8a
    + Добавлен модуль управления тележкой promauto.mpt
 roboplant:
    + Добавлен блок REFA
 messenger:
    + Добавлен плагин и модуль для отправки e-mail
 rpclient:
    * Изменен идентификатор ответ неподдерживаемое команды с "400 NOT SUPPORTED" на "400"
 system:
    * Отменена проверка в prepare наличие shutdown тега
 wessvr:
    * Параметр архива interval может принимать отрицательное значение для исключения проверки периода
    + В fetch_main добавлен аргумент ANDTEXT
 core:
    + Добавлен параметр log.mode (назначение в описании "Общие настройки")


1.3.1 [2018-07-31]
 peripherial:
    * Исправлен баг подсчета Crc8 в протоколе AA55
    * Исправлены имена тегов DA301
    + Добавлен модуль promauto.upsnano
    + Добавлен модуль mercury.m230


1.3.0 [2018-03-29]
 arcsvr:
    + Добавлен плагин arcsvr
 core:
    + Рефакторинг api и логгирования
    + Введена система межмодульных сообщений
 rpclient:
    + Добавлена поддержка команды RELOAD
 rpsvrtcp:
    + Добавлена поддержка команды RELOAD
 wessvr:
    * Устранен ряд ошибок, в т.ч. критических
    + Добавлены команды sweep, wmax, wmaxlist
 tcpserver:
    * Добавлено предотвращение преждевременного подключения клиентов


1.2.0 [2017-11-09]
 wessvr:
    + Добавлен плагин wessvr
 peripherial:
    * Добавлена проверка соответствия адреса в запросе и ответе в протоколе modbus
    * Исправлен неправильный discard
 serial:
    * Для tcp-портов сделано по умолчанию tcp_nodelay=on
 roboplant:
    + Добавлено устройство STMD


1.1.0 [2017-08-15]
 * Обновлены зависимости до последних стабильных версий
 * Файлы зависимостей теперь хранятся без номера версий в имени файла
 * Добавлена папка <root>/lib для хранения зависимостей, необходимых в designtime
 * В папке <root>/jar/lib теперь хранятся зависимости, необходимые только в runtime
 * Измененена структура каталогов папки src под стандарт maven
 * Добавлен проект maven
 * Добавлен проект intellij idea
 * Переработан ant build.xml
 * Добавлена документация и ее экспорт с вики в <root>/doc
 peripherial:
    * Переработан модуль PDioVlvModule
    + Добавлен модуль idsdrive.ecz
    + Добавлен модуль buhler.fbal
    + Добавлен модуль modbus.ig5
 system:
    * Добавлен тег shutdown.enable
 tagsaver:
    * Исправлен баг в команде load (проблема с контрольной суммой)
 roboplant:
    * Исправлен баг в SEQD (неправильное состояние при приостановке запуска)
 rpclient:
    + Добавлены аварийные теги alarm.values


1.0.10 [2017-07-07]
 tagsaver:
    + Добавлена команад load
 roboplant:
    + Добавлены новые операции в SCN
    + Добавлены устройства VALA и TAGA
    + В SEQC реализован флаг "исключительное владение", изменена работа флага "прозрачность"
    + В MCHB добавлены флаги b9 и b10
    + Реализовано устройство MIXB
 peripherial:
    + Добавлен модуль innover.isd
    + Добавлен модуль delta.vfdm
    + Добавлен модуль modbus
 serial:
    + Добавлен порт modbustcp
 core.tags:
    + Добавлено семейство классов тегов TagRW


1.0.9 [2017-04-11]
 database:
    * Исправлена регистрация нотификаций
    + Добавлена возможность в dbscr использовать многострочный текст
 peripherial:
    + Добавлен модуль promauto.pdiovlv
    + Добавлен модуль owen.ma110-224.1t
    * Исправлена ошибка в команде reload: не передавалось значение enable
 roboplant:
    + Добавлено устройство STMC
    * Исправлен reload: не обновлялись флаги тегов
 script:
    + Разрешено в нескольких calc использовать один и тотже result тег


1.0.8 [2017-02-14]
 peripherial:
    + Добавлен модуль owen.trm212
 roboplant:
    + Добавлено устройство ZDVB


1.0.7 [2016-10-14]
 database:
    * Добавлен плагин database и модуль firebird
 roboplant:
    + Добавлено устройство DESH
    * В SEQD добавлена поддержка Flags.b0 для управления режимами входа Suspend
    * Добавлено предупреждение о наличии в именах тегов недопустимых символов
    * GLSA преобразовано в подключаемое устройство (ConnectDevice)
    * SYS реализовано время и дата
 peripherial:
    + Добавлен модуль schneider.atv31
    + Добавлен модуль hygrostek.da301
    * в promauto.gelios.pass добавлены теги kg
 tagsaver:
    * Исправлен баг кодировки по умолчанию


1.0.6 [2016-07-14]
 rpsvrtcp:
    * Исправлена ошибка передачи отрицательных значений в команде GETCHG
 peripherial:
    + Добавлен модуль notis.a100


1.0.5 [2016-07-14]
 tcpserver:
    + Добавлен параметр aliveTimout_s для предотвращения скопления отвалившихся клиентов
 peripherial:
    + Добавлен тег SvrLive для модуля promauto.rfidreader


1.0.4 [2016-06-27]
 peripherial:
    + Добавлен модуль считывателя карт "promauto.rfidreader"


1.0.3 [2016-06-24]
 tagsaver:
    * Исправлена запись в файл изменений (обрезался символ перевода строки)


1.0.2 [2016-05-27]
 tagsaver:
    + Изменен формат файлов сохранения - добавлено: номер версии формата, время изменения значения, контрольная сумма crc32.
 serial:
    + Для nport и usr добавлен конф.параметр no_tcpdelay.
    + Добавлены теги состояния портов.
 peripherial:
    + Добавлена команда и параметр logerror
    - Удалена команда debugInfoError
    + оптимизирована запись в icpcon протоколе
 core:
    * исправлено "забывание" командным диспатчером команд модуля после выполенения reload


1.0.1 [2016-05-19]
 core:
    + Добавлена команда version.
 script: 
    + Определение переменных var в одну строку. Возможность устанавливать тегам переменных флаги autosave и hidden.

